summaryrefslogtreecommitdiff
path: root/src/share/common
blob: c88857e44adabca90d57bb02358bcce92d16f67d (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$@"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$@"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" = 'true' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local string
  286. local tempfile
  287. file="$1"
  288. string="$2"
  289. if [ -z "$file" -o -z "$string" ] ; then
  290. return 1
  291. fi
  292. if [ ! -e "$file" ] ; then
  293. return 1
  294. fi
  295. # if the string is in the file...
  296. if grep -q -F "$string" "$file" 2>/dev/null ; then
  297. tempfile=$(mktemp "${file}.XXXXXXX") || \
  298. failure "Unable to make temp file '${file}.XXXXXXX'"
  299. # remove the line with the string, and return 0
  300. grep -v -F "$string" "$file" >"$tempfile"
  301. cat "$tempfile" > "$file"
  302. rm "$tempfile"
  303. return 0
  304. # otherwise return 1
  305. else
  306. return 1
  307. fi
  308. }
  309. # remove all lines with MonkeySphere strings in file
  310. remove_monkeysphere_lines() {
  311. local file
  312. local tempfile
  313. file="$1"
  314. # return error if file does not exist
  315. if [ ! -e "$file" ] ; then
  316. return 1
  317. fi
  318. # just return ok if the file is empty, since there aren't any
  319. # lines to remove
  320. if [ ! -s "$file" ] ; then
  321. return 0
  322. fi
  323. tempfile=$(mktemp "${file}.XXXXXXX") || \
  324. failure "Could not make temporary file '${file}.XXXXXXX'."
  325. egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
  326. "$file" >"$tempfile"
  327. cat "$tempfile" > "$file"
  328. rm "$tempfile"
  329. }
  330. # translate ssh-style path variables %h and %u
  331. translate_ssh_variables() {
  332. local uname
  333. local home
  334. uname="$1"
  335. path="$2"
  336. # get the user's home directory
  337. userHome=$(get_homedir "$uname")
  338. # translate '%u' to user name
  339. path=${path/\%u/"$uname"}
  340. # translate '%h' to user home directory
  341. path=${path/\%h/"$userHome"}
  342. echo "$path"
  343. }
  344. # test that a string to conforms to GPG's expiration format
  345. test_gpg_expire() {
  346. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  347. }
  348. # check that a file is properly owned, and that all it's parent
  349. # directories are not group/other writable
  350. check_key_file_permissions() {
  351. local uname
  352. local path
  353. local stat
  354. local access
  355. local gAccess
  356. local oAccess
  357. # function to check that the given permission corresponds to writability
  358. is_write() {
  359. [ "$1" = "w" ]
  360. }
  361. uname="$1"
  362. path="$2"
  363. log debug "checking path permission '$path'..."
  364. # rewrite path if it points to a symlink
  365. if [ -h "$path" ] ; then
  366. path=$(readlink -f "$path")
  367. log debug "checking path symlink '$path'..."
  368. fi
  369. # return 255 if cannot stat file
  370. if ! stat=$(ls -ld "$path" 2>/dev/null) ; then
  371. log error "could not stat path '$path'."
  372. return 255
  373. fi
  374. owner=$(echo "$stat" | awk '{ print $3 }')
  375. gAccess=$(echo "$stat" | cut -c6)
  376. oAccess=$(echo "$stat" | cut -c9)
  377. # return 1 if path has invalid owner
  378. if [ "$owner" != "$uname" -a "$owner" != 'root' ] ; then
  379. log error "improper ownership on path '$path':"
  380. log error " $owner != ($uname|root)"
  381. return 1
  382. fi
  383. # return 2 if path has group or other writability
  384. if is_write "$gAccess" || is_write "$oAccess" ; then
  385. log error "improper group or other writability on path '$path':"
  386. log error " group: $gAccess, other: $oAccess"
  387. return 2
  388. fi
  389. # return zero if all clear, or go to next path
  390. if [ "$path" = '/' ] ; then
  391. log debug "path ok."
  392. return 0
  393. else
  394. check_key_file_permissions "$uname" $(dirname "$path")
  395. fi
  396. }
  397. # return a list of all users on the system
  398. list_users() {
  399. if type getent &>/dev/null ; then
  400. # for linux and FreeBSD systems
  401. getent passwd | cut -d: -f1
  402. elif type dscl &>/dev/null ; then
  403. # for Darwin systems
  404. dscl localhost -list /Search/Users
  405. else
  406. failure "Neither getent or dscl is in the path! Could not determine list of users."
  407. fi
  408. }
  409. # return the path to the home directory of a user
  410. get_homedir() {
  411. local uname=${1:-`whoami`}
  412. eval "echo ~${uname}"
  413. }
  414. ### CONVERSION UTILITIES
  415. # output the ssh key for a given key ID
  416. gpg2ssh() {
  417. local keyID
  418. keyID="$1"
  419. gpg --export "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  420. }
  421. # output known_hosts line from ssh key
  422. ssh2known_hosts() {
  423. local host
  424. local port
  425. local key
  426. # FIXME this does not properly deal with IPv6 hosts using the
  427. # standard port (because it's unclear whether their final
  428. # colon-delimited address section is a port number or an address
  429. # string)
  430. host=${1%:*}
  431. port=${1##*:}
  432. key="$2"
  433. # specify the host and port properly for new ssh known_hosts
  434. # format
  435. if [ "$port" != "$host" ] ; then
  436. host="[${host}]:${port}"
  437. fi
  438. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  439. }
  440. # output authorized_keys line from ssh key
  441. ssh2authorized_keys() {
  442. local userID
  443. local key
  444. userID="$1"
  445. key="$2"
  446. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  447. }
  448. # convert key from gpg to ssh known_hosts format
  449. gpg2known_hosts() {
  450. local host
  451. local keyID
  452. local key
  453. host="$1"
  454. keyID="$2"
  455. key=$(gpg2ssh "$keyID")
  456. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  457. # all lines in the known_hosts file. why?
  458. # NOTE: just in case, the COMMENT can be matched with the
  459. # following regexp:
  460. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  461. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  462. }
  463. # convert key from gpg to ssh authorized_keys format
  464. gpg2authorized_keys() {
  465. local userID
  466. local keyID
  467. local key
  468. userID="$1"
  469. keyID="$2"
  470. key=$(gpg2ssh "$keyID")
  471. # NOTE: just in case, the COMMENT can be matched with the
  472. # following regexp:
  473. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  474. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  475. }
  476. ### GPG UTILITIES
  477. # retrieve all keys with given user id from keyserver
  478. # FIXME: need to figure out how to retrieve all matching keys
  479. # (not just first N (5 in this case))
  480. gpg_fetch_userid() {
  481. local returnCode=0
  482. local userID
  483. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  484. return 0
  485. fi
  486. userID="$1"
  487. log verbose " checking keyserver $KEYSERVER... "
  488. echo 1,2,3,4,5 | \
  489. gpg --quiet --batch --with-colons \
  490. --command-fd 0 --keyserver "$KEYSERVER" \
  491. --search ="$userID" &>/dev/null
  492. returnCode="$?"
  493. return "$returnCode"
  494. }
  495. ########################################################################
  496. ### PROCESSING FUNCTIONS
  497. # userid and key policy checking
  498. # the following checks policy on the returned keys
  499. # - checks that full key has appropriate valididy (u|f)
  500. # - checks key has specified capability (REQUIRED_*_KEY_CAPABILITY)
  501. # - checks that requested user ID has appropriate validity
  502. # (see /usr/share/doc/gnupg/DETAILS.gz)
  503. # output is one line for every found key, in the following format:
  504. #
  505. # flag:sshKey
  506. #
  507. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  508. # "sshKey" is the translated gpg key
  509. #
  510. # all log output must go to stderr, as stdout is used to pass the
  511. # flag:sshKey to the calling function.
  512. #
  513. # expects global variable: "MODE"
  514. process_user_id() {
  515. local returnCode=0
  516. local userID
  517. local requiredCapability
  518. local requiredPubCapability
  519. local gpgOut
  520. local type
  521. local validity
  522. local keyid
  523. local uidfpr
  524. local usage
  525. local keyOK
  526. local uidOK
  527. local lastKey
  528. local lastKeyOK
  529. local fingerprint
  530. userID="$1"
  531. # set the required key capability based on the mode
  532. if [ "$MODE" = 'known_hosts' ] ; then
  533. requiredCapability="$REQUIRED_HOST_KEY_CAPABILITY"
  534. elif [ "$MODE" = 'authorized_keys' ] ; then
  535. requiredCapability="$REQUIRED_USER_KEY_CAPABILITY"
  536. fi
  537. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  538. # fetch the user ID if necessary/requested
  539. gpg_fetch_userid "$userID"
  540. # output gpg info for (exact) userid and store
  541. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  542. --with-fingerprint --with-fingerprint \
  543. ="$userID" 2>/dev/null) || returnCode="$?"
  544. # if the gpg query return code is not 0, return 1
  545. if [ "$returnCode" -ne 0 ] ; then
  546. log verbose " no primary keys found."
  547. return 1
  548. fi
  549. # loop over all lines in the gpg output and process.
  550. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  551. while IFS=: read -r type validity keyid uidfpr usage ; do
  552. # process based on record type
  553. case $type in
  554. 'pub') # primary keys
  555. # new key, wipe the slate
  556. keyOK=
  557. uidOK=
  558. lastKey=pub
  559. lastKeyOK=
  560. fingerprint=
  561. log verbose " primary key found: $keyid"
  562. # if overall key is not valid, skip
  563. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  564. log debug " - unacceptable primary key validity ($validity)."
  565. continue
  566. fi
  567. # if overall key is disabled, skip
  568. if check_capability "$usage" 'D' ; then
  569. log debug " - key disabled."
  570. continue
  571. fi
  572. # if overall key capability is not ok, skip
  573. if ! check_capability "$usage" $requiredPubCapability ; then
  574. log debug " - unacceptable primary key capability ($usage)."
  575. continue
  576. fi
  577. # mark overall key as ok
  578. keyOK=true
  579. # mark primary key as ok if capability is ok
  580. if check_capability "$usage" $requiredCapability ; then
  581. lastKeyOK=true
  582. fi
  583. ;;
  584. 'uid') # user ids
  585. if [ "$lastKey" != pub ] ; then
  586. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  587. continue
  588. fi
  589. # if an acceptable user ID was already found, skip
  590. if [ "$uidOK" = 'true' ] ; then
  591. continue
  592. fi
  593. # if the user ID does matches...
  594. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  595. # and the user ID validity is ok
  596. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  597. # mark user ID acceptable
  598. uidOK=true
  599. else
  600. log debug " - unacceptable user ID validity ($validity)."
  601. fi
  602. else
  603. continue
  604. fi
  605. # output a line for the primary key
  606. # 0 = ok, 1 = bad
  607. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  608. log verbose " * acceptable primary key."
  609. if [ -z "$sshKey" ] ; then
  610. log error " ! primary key could not be translated (not RSA?)."
  611. else
  612. echo "0:${sshKey}"
  613. fi
  614. else
  615. log debug " - unacceptable primary key."
  616. if [ -z "$sshKey" ] ; then
  617. log debug " ! primary key could not be translated (not RSA?)."
  618. else
  619. echo "1:${sshKey}"
  620. fi
  621. fi
  622. ;;
  623. 'sub') # sub keys
  624. # unset acceptability of last key
  625. lastKey=sub
  626. lastKeyOK=
  627. fingerprint=
  628. # don't bother with sub keys if the primary key is not valid
  629. if [ "$keyOK" != true ] ; then
  630. continue
  631. fi
  632. # don't bother with sub keys if no user ID is acceptable:
  633. if [ "$uidOK" != true ] ; then
  634. continue
  635. fi
  636. # if sub key validity is not ok, skip
  637. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  638. log debug " - unacceptable sub key validity ($validity)."
  639. continue
  640. fi
  641. # if sub key capability is not ok, skip
  642. if ! check_capability "$usage" $requiredCapability ; then
  643. log debug " - unacceptable sub key capability ($usage)."
  644. continue
  645. fi
  646. # mark sub key as ok
  647. lastKeyOK=true
  648. ;;
  649. 'fpr') # key fingerprint
  650. fingerprint="$uidfpr"
  651. sshKey=$(gpg2ssh "$fingerprint")
  652. # if the last key was the pub key, skip
  653. if [ "$lastKey" = pub ] ; then
  654. continue
  655. fi
  656. # output a line for the sub key
  657. # 0 = ok, 1 = bad
  658. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  659. log verbose " * acceptable sub key."
  660. if [ -z "$sshKey" ] ; then
  661. log error " ! sub key could not be translated (not RSA?)."
  662. else
  663. echo "0:${sshKey}"
  664. fi
  665. else
  666. log debug " - unacceptable sub key."
  667. if [ -z "$sshKey" ] ; then
  668. log debug " ! sub key could not be translated (not RSA?)."
  669. else
  670. echo "1:${sshKey}"
  671. fi
  672. fi
  673. ;;
  674. esac
  675. done | sort -t: -k1 -n -r
  676. # NOTE: this last sort is important so that the "good" keys (key
  677. # flag '0') come last. This is so that they take precedence when
  678. # being processed in the key files over "bad" keys (key flag '1')
  679. }
  680. # process a single host in the known_host file
  681. process_host_known_hosts() {
  682. local host
  683. local userID
  684. local noKey=
  685. local nKeys
  686. local nKeysOK
  687. local ok
  688. local sshKey
  689. local tmpfile
  690. # set the key processing mode
  691. export MODE='known_hosts'
  692. host="$1"
  693. userID="ssh://${host}"
  694. log verbose "processing: $host"
  695. nKeys=0
  696. nKeysOK=0
  697. IFS=$'\n'
  698. for line in $(process_user_id "${userID}") ; do
  699. # note that key was found
  700. nKeys=$((nKeys+1))
  701. ok=$(echo "$line" | cut -d: -f1)
  702. sshKey=$(echo "$line" | cut -d: -f2)
  703. if [ -z "$sshKey" ] ; then
  704. continue
  705. fi
  706. # remove any old host key line, and note if removed nothing is
  707. # removed
  708. remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
  709. # if key OK, add new host line
  710. if [ "$ok" -eq '0' ] ; then
  711. # note that key was found ok
  712. nKeysOK=$((nKeysOK+1))
  713. # hash if specified
  714. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  715. # FIXME: this is really hackish cause ssh-keygen won't
  716. # hash from stdin to stdout
  717. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  718. ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
  719. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  720. cat "$tmpfile" >> "$KNOWN_HOSTS"
  721. rm -f "$tmpfile" "${tmpfile}.old"
  722. else
  723. ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
  724. fi
  725. # log if this is a new key to the known_hosts file
  726. if [ "$noKey" ] ; then
  727. log info "* new key for $host added to known_hosts file."
  728. fi
  729. fi
  730. done
  731. # if at least one key was found...
  732. if [ "$nKeys" -gt 0 ] ; then
  733. # if ok keys were found, return 0
  734. if [ "$nKeysOK" -gt 0 ] ; then
  735. return 0
  736. # else return 2
  737. else
  738. return 2
  739. fi
  740. # if no keys were found, return 1
  741. else
  742. return 1
  743. fi
  744. }
  745. # update the known_hosts file for a set of hosts listed on command
  746. # line
  747. update_known_hosts() {
  748. local returnCode=0
  749. local nHosts
  750. local nHostsOK
  751. local nHostsBAD
  752. local fileCheck
  753. local host
  754. # the number of hosts specified on command line
  755. nHosts="$#"
  756. nHostsOK=0
  757. nHostsBAD=0
  758. # touch the known_hosts file so that the file permission check
  759. # below won't fail upon not finding the file
  760. (umask 0022 && touch "$KNOWN_HOSTS")
  761. # check permissions on the known_hosts file path
  762. check_key_file_permissions $(whoami) "$KNOWN_HOSTS" || failure
  763. # create a lockfile on known_hosts:
  764. lock create "$KNOWN_HOSTS"
  765. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  766. trap "lock remove $KNOWN_HOSTS" EXIT
  767. # note pre update file checksum
  768. fileCheck="$(file_hash "$KNOWN_HOSTS")"
  769. for host ; do
  770. # process the host
  771. process_host_known_hosts "$host" || returnCode="$?"
  772. # note the result
  773. case "$returnCode" in
  774. 0)
  775. nHostsOK=$((nHostsOK+1))
  776. ;;
  777. 2)
  778. nHostsBAD=$((nHostsBAD+1))
  779. ;;
  780. esac
  781. # touch the lockfile, for good measure.
  782. lock touch "$KNOWN_HOSTS"
  783. done
  784. # remove the lockfile and the trap
  785. lock remove "$KNOWN_HOSTS"
  786. trap - EXIT
  787. # note if the known_hosts file was updated
  788. if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
  789. log debug "known_hosts file updated."
  790. fi
  791. # if an acceptable host was found, return 0
  792. if [ "$nHostsOK" -gt 0 ] ; then
  793. return 0
  794. # else if no ok hosts were found...
  795. else
  796. # if no bad host were found then no hosts were found at all,
  797. # and return 1
  798. if [ "$nHostsBAD" -eq 0 ] ; then
  799. return 1
  800. # else if at least one bad host was found, return 2
  801. else
  802. return 2
  803. fi
  804. fi
  805. }
  806. # process hosts from a known_hosts file
  807. process_known_hosts() {
  808. local hosts
  809. # exit if the known_hosts file does not exist
  810. if [ ! -e "$KNOWN_HOSTS" ] ; then
  811. failure "known_hosts file '$KNOWN_HOSTS' does not exist."
  812. fi
  813. log debug "processing known_hosts file:"
  814. log debug " $KNOWN_HOSTS"
  815. hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
  816. if [ -z "$hosts" ] ; then
  817. log debug "no hosts to process."
  818. return
  819. fi
  820. # take all the hosts from the known_hosts file (first
  821. # field), grep out all the hashed hosts (lines starting
  822. # with '|')...
  823. update_known_hosts $hosts
  824. }
  825. # process uids for the authorized_keys file
  826. process_uid_authorized_keys() {
  827. local userID
  828. local nKeys
  829. local nKeysOK
  830. local ok
  831. local sshKey
  832. # set the key processing mode
  833. export MODE='authorized_keys'
  834. userID="$1"
  835. log verbose "processing: $userID"
  836. nKeys=0
  837. nKeysOK=0
  838. IFS=$'\n'
  839. for line in $(process_user_id "$userID") ; do
  840. # note that key was found
  841. nKeys=$((nKeys+1))
  842. ok=$(echo "$line" | cut -d: -f1)
  843. sshKey=$(echo "$line" | cut -d: -f2)
  844. if [ -z "$sshKey" ] ; then
  845. continue
  846. fi
  847. # remove the old host key line
  848. remove_line "$AUTHORIZED_KEYS" "$sshKey"
  849. # if key OK, add new host line
  850. if [ "$ok" -eq '0' ] ; then
  851. # note that key was found ok
  852. nKeysOK=$((nKeysOK+1))
  853. ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
  854. fi
  855. done
  856. # if at least one key was found...
  857. if [ "$nKeys" -gt 0 ] ; then
  858. # if ok keys were found, return 0
  859. if [ "$nKeysOK" -gt 0 ] ; then
  860. return 0
  861. # else return 2
  862. else
  863. return 2
  864. fi
  865. # if no keys were found, return 1
  866. else
  867. return 1
  868. fi
  869. }
  870. # update the authorized_keys files from a list of user IDs on command
  871. # line
  872. update_authorized_keys() {
  873. local returnCode=0
  874. local userID
  875. local nIDs
  876. local nIDsOK
  877. local nIDsBAD
  878. local fileCheck
  879. # the number of ids specified on command line
  880. nIDs="$#"
  881. nIDsOK=0
  882. nIDsBAD=0
  883. log debug "updating authorized_keys file:"
  884. log debug " $AUTHORIZED_KEYS"
  885. # check permissions on the authorized_keys file path
  886. check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
  887. # create a lockfile on authorized_keys
  888. lock create "$AUTHORIZED_KEYS"
  889. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  890. trap "lock remove $AUTHORIZED_KEYS" EXIT
  891. # note pre update file checksum
  892. fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
  893. # remove any monkeysphere lines from authorized_keys file
  894. remove_monkeysphere_lines "$AUTHORIZED_KEYS"
  895. for userID ; do
  896. # process the user ID, change return code if key not found for
  897. # user ID
  898. process_uid_authorized_keys "$userID" || returnCode="$?"
  899. # note the result
  900. case "$returnCode" in
  901. 0)
  902. nIDsOK=$((nIDsOK+1))
  903. ;;
  904. 2)
  905. nIDsBAD=$((nIDsBAD+1))
  906. ;;
  907. esac
  908. # touch the lockfile, for good measure.
  909. lock touch "$AUTHORIZED_KEYS"
  910. done
  911. # remove the lockfile and the trap
  912. lock remove "$AUTHORIZED_KEYS"
  913. # remove the trap
  914. trap - EXIT
  915. # note if the authorized_keys file was updated
  916. if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
  917. log debug "authorized_keys file updated."
  918. fi
  919. # if an acceptable id was found, return 0
  920. if [ "$nIDsOK" -gt 0 ] ; then
  921. return 0
  922. # else if no ok ids were found...
  923. else
  924. # if no bad ids were found then no ids were found at all, and
  925. # return 1
  926. if [ "$nIDsBAD" -eq 0 ] ; then
  927. return 1
  928. # else if at least one bad id was found, return 2
  929. else
  930. return 2
  931. fi
  932. fi
  933. }
  934. # process an authorized_user_ids file for authorized_keys
  935. process_authorized_user_ids() {
  936. local line
  937. local nline
  938. local userIDs
  939. authorizedUserIDs="$1"
  940. # exit if the authorized_user_ids file is empty
  941. if [ ! -e "$authorizedUserIDs" ] ; then
  942. failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
  943. fi
  944. log debug "processing authorized_user_ids file:"
  945. log debug " $authorizedUserIDs"
  946. # check permissions on the authorized_user_ids file path
  947. check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
  948. if ! meat "$authorizedUserIDs" >/dev/null ; then
  949. log debug " no user IDs to process."
  950. return
  951. fi
  952. nline=0
  953. # extract user IDs from authorized_user_ids file
  954. IFS=$'\n'
  955. for line in $(meat "$authorizedUserIDs") ; do
  956. userIDs["$nline"]="$line"
  957. nline=$((nline+1))
  958. done
  959. update_authorized_keys "${userIDs[@]}"
  960. }
  961. # takes a gpg key or keys on stdin, and outputs a list of
  962. # fingerprints, one per line:
  963. list_primary_fingerprints() {
  964. local fake=$(msmktempdir)
  965. GNUPGHOME="$fake" gpg --no-tty --quiet --import
  966. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  967. awk -F: '/^fpr:/{ print $10 }'
  968. rm -rf "$fake"
  969. }
  970. check_cruft_file() {
  971. local loc="$1"
  972. local version="$2"
  973. if [ -e "$loc" ] ; then
  974. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  975. fi
  976. }
  977. check_upgrade_dir() {
  978. local loc="$1"
  979. local version="$2"
  980. if [ -d "$loc" ] ; then
  981. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  982. fi
  983. }
  984. ## look for cruft from old versions of the monkeysphere, and notice if
  985. ## upgrades have not been run:
  986. report_cruft() {
  987. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  988. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  989. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  990. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  991. local found=
  992. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  993. if [ -d "$foo" ] ; then
  994. printf "! %s\n" "$foo" | log info
  995. found=true
  996. fi
  997. done
  998. if [ "$found" ] ; then
  999. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  1000. fi
  1001. }